# Геймплей ([EN](gameplay.md) / RU)

[<< Назад](README_ru.md)

![](screenshot.png)

## Описание игровых полей

Игра имеет два поля: **основное** и **перемещаемый участок**.

Основное поле представлено набором **синих** клеток. Игрок не может управлять состоянием данного поля непосредственно.

Перемещаемый участок представлен набором **зелёных** клеток, окружённых жёлтой рамкой. Данное поле располагается над основным и частично перекрывает его. Игрок может управлять положением и ориентацией данного поля. Начальное положение &mdash; **верхний левый угол**.

В начале игры оба поля заполняются **определённым количеством** клеток, **расположенных случайно**.

## Взаимодействие с перемещаемым участком поля

Игрок может **перемещать** данное поле **влево**, **вправо**, **вверх** и **вниз**. При этом перемещаемый участок не может выйти за пределы основного поля.

Игрок может **вращать** данное поле. Вращение осуществляется только **по часовой стрелке** и всегда **кратно 90 градусам**.

Границы данного поля заданы жёлтой рамкой и не зависят от наличия зелёных клеток. Таким образом их отсутствие в какой-либо строке или столбце не уменьшает размер перемещаемого участка. Возможна ситуация, когда данное поле упирается в край основного, хотя сторона, которой оно упирается, лишена каких-либо клеток. Это даёт возможность осуществить вращение поля при любом его положении.

Игрок может **слить** данное поле **с основным**. Это возможно только в том случае, если под зелёными клетками отсутствуют синие. В противном случае слияние недоступно, а конфликтующие клетки отображаются **красным**.

При слиянии полей (см. также ниже) текущий перемещаемый участок удаляется, а вместо него создаётся новый в верхнем левом углу **с таким же количеством** случайно расположенных клеток.

## Функционирование основного поля

Данное поле остаётся статичным на протяжении всей игры за исключением моментов слияния с перемещаемым участком.

При слиянии полей клетки перемещаемого участка добавляются на основное поле и становятся синими.

После этого к данному полю применяются правила игры [&laquo;Жизнь&raquo;](https://ru.wikipedia.org/wiki/Игра_«Жизнь»). При этом поле считается незамкнутым и ограниченным пустыми неизменяемыми клетками. Преобразование осуществляется только на одно поколение.

## Цели игры и статистика

Глобальной целью игры является полная очистка основного поля от синих клеток. Однако на практике её крайне сложно достичь. Поэтому в качестве альтернативы рассматривается **максимальное сокращение** количества этих клеток.

Важно понимать, что моментом, в который оценивается это количество, является момент **после слияния** полей **и применения правил** игры [&laquo;Жизнь&raquo;](https://ru.wikipedia.org/wiki/Игра_«Жизнь») к основному полю.

Игра ведёт некую статистику, запоминая минимальное значение количества синих клеток за все осуществлённые игровые сессии.
